package kmity;

public class AnharmonickeKmity {
  protected double x, v;           /* poloha, rychlost + PP */
  protected double alpha, beta, k; /* konstanty umernosti */
  protected double m;              /* hmotnost */
  protected double t;

  public AnharmonickeKmity(double _x, double _v, double _t,
    double _alpha, double _beta, double _k, double _m)
  {
    x=_x; v=_v; t=_t; alpha=_alpha; beta=_beta; k=_k; m=_m;
  }

  private double Sila(double X, double V)
  {
    return - k * X * (1 + alpha * X * X) - beta * V;
  }
  
  public void Iteruj(double delta_t)
  {
    double x2;
    x2 = x + delta_t * (v + delta_t / (2*m) * Sila(x, v));
    v  += delta_t / (2*m) * (Sila(x, v) + Sila(x2, v));
    x = x2;
    t += delta_t;
  }

  public double X() { return x; }
  public double V() { return v; }
  public double T() { return t; }
}

